/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setColors = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { eye_color, hair_color } = req.body
    if (!eye_color || !hair_color) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }

    // جستجوی کاربر با شماره موبایل ارسالی
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    user.eye_color = eye_color
    user.hair_color = hair_color
    await user.save()

    return res.json({
      message: 'رنگ ها با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
const updateColors = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const { eye_color, hair_color } = req.body

    // اعتبارسنجی داده‌ها
    if (!eye_color || !hair_color) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی ناقص است'
      })
    }

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id

    // یافتن کاربر با استفاده از شناسه کاربر
    const user = await UserModel.findById(userId)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شناسه یافت نشد'
      })
    }

    // به‌روزرسانی اطلاعات رنگ‌ها
    user.eye_color = eye_color
    user.hair_color = hair_color
    await user.save()

    return res.json({
      message: 'رنگ‌ها با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}

module.exports = {
  setColors, updateColors
}
